<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - report.info - QtWidgets/qlistwidget.h</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">QtWidgets</a> - qlistwidget.h<span style="font-size: 80%;"> (source / <a href="qlistwidget.h.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">report.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">3</td>
            <td class="headerCovTableEntry">5</td>
            <td class="headerCovTableEntryLo">60.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2021-03-29 02:25:54</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">2</td>
            <td class="headerCovTableEntry">3</td>
            <td class="headerCovTableEntryLo">66.7 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : /****************************************************************************</a>
<a name="2"><span class="lineNum">       2 </span>            : **</a>
<a name="3"><span class="lineNum">       3 </span>            : ** Copyright (C) 2016 The Qt Company Ltd.</a>
<a name="4"><span class="lineNum">       4 </span>            : ** Contact: https://www.qt.io/licensing/</a>
<a name="5"><span class="lineNum">       5 </span>            : **</a>
<a name="6"><span class="lineNum">       6 </span>            : ** This file is part of the QtWidgets module of the Qt Toolkit.</a>
<a name="7"><span class="lineNum">       7 </span>            : **</a>
<a name="8"><span class="lineNum">       8 </span>            : ** $QT_BEGIN_LICENSE:LGPL$</a>
<a name="9"><span class="lineNum">       9 </span>            : ** Commercial License Usage</a>
<a name="10"><span class="lineNum">      10 </span>            : ** Licensees holding valid commercial Qt licenses may use this file in</a>
<a name="11"><span class="lineNum">      11 </span>            : ** accordance with the commercial license agreement provided with the</a>
<a name="12"><span class="lineNum">      12 </span>            : ** Software or, alternatively, in accordance with the terms contained in</a>
<a name="13"><span class="lineNum">      13 </span>            : ** a written agreement between you and The Qt Company. For licensing terms</a>
<a name="14"><span class="lineNum">      14 </span>            : ** and conditions see https://www.qt.io/terms-conditions. For further</a>
<a name="15"><span class="lineNum">      15 </span>            : ** information use the contact form at https://www.qt.io/contact-us.</a>
<a name="16"><span class="lineNum">      16 </span>            : **</a>
<a name="17"><span class="lineNum">      17 </span>            : ** GNU Lesser General Public License Usage</a>
<a name="18"><span class="lineNum">      18 </span>            : ** Alternatively, this file may be used under the terms of the GNU Lesser</a>
<a name="19"><span class="lineNum">      19 </span>            : ** General Public License version 3 as published by the Free Software</a>
<a name="20"><span class="lineNum">      20 </span>            : ** Foundation and appearing in the file LICENSE.LGPL3 included in the</a>
<a name="21"><span class="lineNum">      21 </span>            : ** packaging of this file. Please review the following information to</a>
<a name="22"><span class="lineNum">      22 </span>            : ** ensure the GNU Lesser General Public License version 3 requirements</a>
<a name="23"><span class="lineNum">      23 </span>            : ** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.</a>
<a name="24"><span class="lineNum">      24 </span>            : **</a>
<a name="25"><span class="lineNum">      25 </span>            : ** GNU General Public License Usage</a>
<a name="26"><span class="lineNum">      26 </span>            : ** Alternatively, this file may be used under the terms of the GNU</a>
<a name="27"><span class="lineNum">      27 </span>            : ** General Public License version 2.0 or (at your option) the GNU General</a>
<a name="28"><span class="lineNum">      28 </span>            : ** Public license version 3 or any later version approved by the KDE Free</a>
<a name="29"><span class="lineNum">      29 </span>            : ** Qt Foundation. The licenses are as published by the Free Software</a>
<a name="30"><span class="lineNum">      30 </span>            : ** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3</a>
<a name="31"><span class="lineNum">      31 </span>            : ** included in the packaging of this file. Please review the following</a>
<a name="32"><span class="lineNum">      32 </span>            : ** information to ensure the GNU General Public License requirements will</a>
<a name="33"><span class="lineNum">      33 </span>            : ** be met: https://www.gnu.org/licenses/gpl-2.0.html and</a>
<a name="34"><span class="lineNum">      34 </span>            : ** https://www.gnu.org/licenses/gpl-3.0.html.</a>
<a name="35"><span class="lineNum">      35 </span>            : **</a>
<a name="36"><span class="lineNum">      36 </span>            : ** $QT_END_LICENSE$</a>
<a name="37"><span class="lineNum">      37 </span>            : **</a>
<a name="38"><span class="lineNum">      38 </span>            : ****************************************************************************/</a>
<a name="39"><span class="lineNum">      39 </span>            : </a>
<a name="40"><span class="lineNum">      40 </span>            : #ifndef QLISTWIDGET_H</a>
<a name="41"><span class="lineNum">      41 </span>            : #define QLISTWIDGET_H</a>
<a name="42"><span class="lineNum">      42 </span>            : </a>
<a name="43"><span class="lineNum">      43 </span>            : #include &lt;QtWidgets/qtwidgetsglobal.h&gt;</a>
<a name="44"><span class="lineNum">      44 </span>            : #include &lt;QtWidgets/qlistview.h&gt;</a>
<a name="45"><span class="lineNum">      45 </span>            : #include &lt;QtCore/qvariant.h&gt;</a>
<a name="46"><span class="lineNum">      46 </span>            : #include &lt;QtCore/qvector.h&gt;</a>
<a name="47"><span class="lineNum">      47 </span>            : #include &lt;QtCore/qitemselectionmodel.h&gt;</a>
<a name="48"><span class="lineNum">      48 </span>            : </a>
<a name="49"><span class="lineNum">      49 </span>            : QT_REQUIRE_CONFIG(listwidget);</a>
<a name="50"><span class="lineNum">      50 </span>            : </a>
<a name="51"><span class="lineNum">      51 </span>            : QT_BEGIN_NAMESPACE</a>
<a name="52"><span class="lineNum">      52 </span>            : </a>
<a name="53"><span class="lineNum">      53 </span>            : class QListWidget;</a>
<a name="54"><span class="lineNum">      54 </span>            : class QListModel;</a>
<a name="55"><span class="lineNum">      55 </span>            : class QWidgetItemData;</a>
<a name="56"><span class="lineNum">      56 </span>            : class QListWidgetItemPrivate;</a>
<a name="57"><span class="lineNum">      57 </span>            : </a>
<a name="58"><span class="lineNum">      58 </span>            : class Q_WIDGETS_EXPORT QListWidgetItem</a>
<a name="59"><span class="lineNum">      59 </span>            : {</a>
<a name="60"><span class="lineNum">      60 </span>            :     friend class QListModel;</a>
<a name="61"><span class="lineNum">      61 </span>            :     friend class QListWidget;</a>
<a name="62"><span class="lineNum">      62 </span>            : public:</a>
<a name="63"><span class="lineNum">      63 </span>            :     enum ItemType { Type = 0, UserType = 1000 };</a>
<a name="64"><span class="lineNum">      64 </span>            :     explicit QListWidgetItem(QListWidget *listview = nullptr, int type = Type);</a>
<a name="65"><span class="lineNum">      65 </span>            :     explicit QListWidgetItem(const QString &amp;text, QListWidget *listview = nullptr, int type = Type);</a>
<a name="66"><span class="lineNum">      66 </span>            :     explicit QListWidgetItem(const QIcon &amp;icon, const QString &amp;text,</a>
<a name="67"><span class="lineNum">      67 </span>            :                              QListWidget *listview = nullptr, int type = Type);</a>
<a name="68"><span class="lineNum">      68 </span>            :     QListWidgetItem(const QListWidgetItem &amp;other);</a>
<a name="69"><span class="lineNum">      69 </span>            :     virtual ~QListWidgetItem();</a>
<a name="70"><span class="lineNum">      70 </span>            : </a>
<a name="71"><span class="lineNum">      71 </span>            :     virtual QListWidgetItem *clone() const;</a>
<a name="72"><span class="lineNum">      72 </span>            : </a>
<a name="73"><span class="lineNum">      73 </span>            :     inline QListWidget *listWidget() const { return view; }</a>
<a name="74"><span class="lineNum">      74 </span>            : </a>
<a name="75"><span class="lineNum">      75 </span>            :     void setSelected(bool select);</a>
<a name="76"><span class="lineNum">      76 </span>            :     bool isSelected() const;</a>
<a name="77"><span class="lineNum">      77 </span>            : </a>
<a name="78"><span class="lineNum">      78 </span>            :     inline void setHidden(bool hide);</a>
<a name="79"><span class="lineNum">      79 </span>            :     inline bool isHidden() const;</a>
<a name="80"><span class="lineNum">      80 </span>            : </a>
<a name="81"><span class="lineNum">      81 </span>            :     inline Qt::ItemFlags flags() const { return itemFlags; }</a>
<a name="82"><span class="lineNum">      82 </span>            :     void setFlags(Qt::ItemFlags flags);</a>
<a name="83"><span class="lineNum">      83 </span>            : </a>
<a name="84"><span class="lineNum">      84 </span><span class="lineCov">         92 :     inline QString text() const</span></a>
<a name="85"><span class="lineNum">      85 </span><span class="lineCov">        184 :         { return data(Qt::DisplayRole).toString(); }</span></a>
<a name="86"><span class="lineNum">      86 </span>            :     inline void setText(const QString &amp;text);</a>
<a name="87"><span class="lineNum">      87 </span>            : </a>
<a name="88"><span class="lineNum">      88 </span>            :     inline QIcon icon() const</a>
<a name="89"><span class="lineNum">      89 </span>            :         { return qvariant_cast&lt;QIcon&gt;(data(Qt::DecorationRole)); }</a>
<a name="90"><span class="lineNum">      90 </span>            :     inline void setIcon(const QIcon &amp;icon);</a>
<a name="91"><span class="lineNum">      91 </span>            : </a>
<a name="92"><span class="lineNum">      92 </span>            :     inline QString statusTip() const</a>
<a name="93"><span class="lineNum">      93 </span>            :         { return data(Qt::StatusTipRole).toString(); }</a>
<a name="94"><span class="lineNum">      94 </span>            :     inline void setStatusTip(const QString &amp;statusTip);</a>
<a name="95"><span class="lineNum">      95 </span>            : </a>
<a name="96"><span class="lineNum">      96 </span>            : #ifndef QT_NO_TOOLTIP</a>
<a name="97"><span class="lineNum">      97 </span>            :     inline QString toolTip() const</a>
<a name="98"><span class="lineNum">      98 </span>            :         { return data(Qt::ToolTipRole).toString(); }</a>
<a name="99"><span class="lineNum">      99 </span>            :     inline void setToolTip(const QString &amp;toolTip);</a>
<a name="100"><span class="lineNum">     100 </span>            : #endif</a>
<a name="101"><span class="lineNum">     101 </span>            : </a>
<a name="102"><span class="lineNum">     102 </span>            : #if QT_CONFIG(whatsthis)</a>
<a name="103"><span class="lineNum">     103 </span>            :     inline QString whatsThis() const</a>
<a name="104"><span class="lineNum">     104 </span>            :         { return data(Qt::WhatsThisRole).toString(); }</a>
<a name="105"><span class="lineNum">     105 </span>            :     inline void setWhatsThis(const QString &amp;whatsThis);</a>
<a name="106"><span class="lineNum">     106 </span>            : #endif</a>
<a name="107"><span class="lineNum">     107 </span>            : </a>
<a name="108"><span class="lineNum">     108 </span>            :     inline QFont font() const</a>
<a name="109"><span class="lineNum">     109 </span>            :         { return qvariant_cast&lt;QFont&gt;(data(Qt::FontRole)); }</a>
<a name="110"><span class="lineNum">     110 </span>            :     inline void setFont(const QFont &amp;font);</a>
<a name="111"><span class="lineNum">     111 </span>            : </a>
<a name="112"><span class="lineNum">     112 </span>            :     inline int textAlignment() const</a>
<a name="113"><span class="lineNum">     113 </span>            :         { return data(Qt::TextAlignmentRole).toInt(); }</a>
<a name="114"><span class="lineNum">     114 </span>            :     inline void setTextAlignment(int alignment)</a>
<a name="115"><span class="lineNum">     115 </span>            :         { setData(Qt::TextAlignmentRole, alignment); }</a>
<a name="116"><span class="lineNum">     116 </span>            : </a>
<a name="117"><span class="lineNum">     117 </span>            : #if QT_DEPRECATED_SINCE(5, 13)</a>
<a name="118"><span class="lineNum">     118 </span>            :     QT_DEPRECATED_X (&quot;Use QListWidgetItem::background() instead&quot;)</a>
<a name="119"><span class="lineNum">     119 </span>            :     inline QColor backgroundColor() const</a>
<a name="120"><span class="lineNum">     120 </span>            :         { return qvariant_cast&lt;QColor&gt;(data(Qt::BackgroundRole)); }</a>
<a name="121"><span class="lineNum">     121 </span>            : #endif</a>
<a name="122"><span class="lineNum">     122 </span>            :     // no QT_DEPRECATED_SINCE because it is a virtual function</a>
<a name="123"><span class="lineNum">     123 </span>            :     QT_DEPRECATED_X (&quot;Use QListWidgetItem::setBackground() instead&quot;)</a>
<a name="124"><span class="lineNum">     124 </span>            :     virtual void setBackgroundColor(const QColor &amp;color)</a>
<a name="125"><span class="lineNum">     125 </span>            :         { setData(Qt::BackgroundRole, color); }</a>
<a name="126"><span class="lineNum">     126 </span>            : </a>
<a name="127"><span class="lineNum">     127 </span>            :     inline QBrush background() const</a>
<a name="128"><span class="lineNum">     128 </span>            :         { return qvariant_cast&lt;QBrush&gt;(data(Qt::BackgroundRole)); }</a>
<a name="129"><span class="lineNum">     129 </span>            :     inline void setBackground(const QBrush &amp;brush)</a>
<a name="130"><span class="lineNum">     130 </span>            :         { setData(Qt::BackgroundRole, brush.style() != Qt::NoBrush ? QVariant(brush) : QVariant()); }</a>
<a name="131"><span class="lineNum">     131 </span>            : </a>
<a name="132"><span class="lineNum">     132 </span>            : #if QT_DEPRECATED_SINCE(5, 13)</a>
<a name="133"><span class="lineNum">     133 </span>            :     QT_DEPRECATED_X (&quot;Use QListWidgetItem::foreground() instead&quot;)</a>
<a name="134"><span class="lineNum">     134 </span>            :     inline QColor textColor() const</a>
<a name="135"><span class="lineNum">     135 </span>            :         { return qvariant_cast&lt;QColor&gt;(data(Qt::ForegroundRole)); }</a>
<a name="136"><span class="lineNum">     136 </span>            :     QT_DEPRECATED_X (&quot;Use QListWidgetItem::setForeground() instead&quot;)</a>
<a name="137"><span class="lineNum">     137 </span>            :     inline void setTextColor(const QColor &amp;color)</a>
<a name="138"><span class="lineNum">     138 </span>            :         { setData(Qt::ForegroundRole, color); }</a>
<a name="139"><span class="lineNum">     139 </span>            : #endif</a>
<a name="140"><span class="lineNum">     140 </span>            : </a>
<a name="141"><span class="lineNum">     141 </span>            :     inline QBrush foreground() const</a>
<a name="142"><span class="lineNum">     142 </span>            :         { return qvariant_cast&lt;QBrush&gt;(data(Qt::ForegroundRole)); }</a>
<a name="143"><span class="lineNum">     143 </span>            :     inline void setForeground(const QBrush &amp;brush)</a>
<a name="144"><span class="lineNum">     144 </span>            :         { setData(Qt::ForegroundRole, brush.style() != Qt::NoBrush ? QVariant(brush) : QVariant()); }</a>
<a name="145"><span class="lineNum">     145 </span>            : </a>
<a name="146"><span class="lineNum">     146 </span>            :     inline Qt::CheckState checkState() const</a>
<a name="147"><span class="lineNum">     147 </span>            :         { return static_cast&lt;Qt::CheckState&gt;(data(Qt::CheckStateRole).toInt()); }</a>
<a name="148"><span class="lineNum">     148 </span>            :     inline void setCheckState(Qt::CheckState state)</a>
<a name="149"><span class="lineNum">     149 </span>            :         { setData(Qt::CheckStateRole, static_cast&lt;int&gt;(state)); }</a>
<a name="150"><span class="lineNum">     150 </span>            : </a>
<a name="151"><span class="lineNum">     151 </span>            :     inline QSize sizeHint() const</a>
<a name="152"><span class="lineNum">     152 </span>            :         { return qvariant_cast&lt;QSize&gt;(data(Qt::SizeHintRole)); }</a>
<a name="153"><span class="lineNum">     153 </span>            :     inline void setSizeHint(const QSize &amp;size)</a>
<a name="154"><span class="lineNum">     154 </span>            :         { setData(Qt::SizeHintRole, size.isValid() ? QVariant(size) : QVariant()); }</a>
<a name="155"><span class="lineNum">     155 </span>            : </a>
<a name="156"><span class="lineNum">     156 </span>            :     virtual QVariant data(int role) const;</a>
<a name="157"><span class="lineNum">     157 </span>            :     virtual void setData(int role, const QVariant &amp;value);</a>
<a name="158"><span class="lineNum">     158 </span>            : </a>
<a name="159"><span class="lineNum">     159 </span>            :     virtual bool operator&lt;(const QListWidgetItem &amp;other) const;</a>
<a name="160"><span class="lineNum">     160 </span>            : </a>
<a name="161"><span class="lineNum">     161 </span>            : #ifndef QT_NO_DATASTREAM</a>
<a name="162"><span class="lineNum">     162 </span>            :     virtual void read(QDataStream &amp;in);</a>
<a name="163"><span class="lineNum">     163 </span>            :     virtual void write(QDataStream &amp;out) const;</a>
<a name="164"><span class="lineNum">     164 </span>            : #endif</a>
<a name="165"><span class="lineNum">     165 </span>            :     QListWidgetItem &amp;operator=(const QListWidgetItem &amp;other);</a>
<a name="166"><span class="lineNum">     166 </span>            : </a>
<a name="167"><span class="lineNum">     167 </span>            :     inline int type() const { return rtti; }</a>
<a name="168"><span class="lineNum">     168 </span>            : </a>
<a name="169"><span class="lineNum">     169 </span>            : private:</a>
<a name="170"><span class="lineNum">     170 </span>            :     QListModel *listModel() const;</a>
<a name="171"><span class="lineNum">     171 </span>            :     int rtti;</a>
<a name="172"><span class="lineNum">     172 </span>            :     QVector&lt;void *&gt; dummy;</a>
<a name="173"><span class="lineNum">     173 </span>            :     QListWidget *view;</a>
<a name="174"><span class="lineNum">     174 </span>            :     QListWidgetItemPrivate *d;</a>
<a name="175"><span class="lineNum">     175 </span>            :     Qt::ItemFlags itemFlags;</a>
<a name="176"><span class="lineNum">     176 </span>            : };</a>
<a name="177"><span class="lineNum">     177 </span>            : </a>
<a name="178"><span class="lineNum">     178 </span><span class="lineNoCov">          0 : inline void QListWidgetItem::setText(const QString &amp;atext)</span></a>
<a name="179"><span class="lineNum">     179 </span><span class="lineNoCov">          0 : { setData(Qt::DisplayRole, atext); }</span></a>
<a name="180"><span class="lineNum">     180 </span>            : </a>
<a name="181"><span class="lineNum">     181 </span>            : inline void QListWidgetItem::setIcon(const QIcon &amp;aicon)</a>
<a name="182"><span class="lineNum">     182 </span>            : { setData(Qt::DecorationRole, aicon); }</a>
<a name="183"><span class="lineNum">     183 </span>            : </a>
<a name="184"><span class="lineNum">     184 </span>            : inline void QListWidgetItem::setStatusTip(const QString &amp;astatusTip)</a>
<a name="185"><span class="lineNum">     185 </span>            : { setData(Qt::StatusTipRole, astatusTip); }</a>
<a name="186"><span class="lineNum">     186 </span>            : </a>
<a name="187"><span class="lineNum">     187 </span>            : #ifndef QT_NO_TOOLTIP</a>
<a name="188"><span class="lineNum">     188 </span>            : inline void QListWidgetItem::setToolTip(const QString &amp;atoolTip)</a>
<a name="189"><span class="lineNum">     189 </span>            : { setData(Qt::ToolTipRole, atoolTip); }</a>
<a name="190"><span class="lineNum">     190 </span>            : #endif</a>
<a name="191"><span class="lineNum">     191 </span>            : </a>
<a name="192"><span class="lineNum">     192 </span>            : #if QT_CONFIG(whatsthis)</a>
<a name="193"><span class="lineNum">     193 </span>            : inline void QListWidgetItem::setWhatsThis(const QString &amp;awhatsThis)</a>
<a name="194"><span class="lineNum">     194 </span>            : { setData(Qt::WhatsThisRole, awhatsThis); }</a>
<a name="195"><span class="lineNum">     195 </span>            : #endif</a>
<a name="196"><span class="lineNum">     196 </span>            : </a>
<a name="197"><span class="lineNum">     197 </span>            : inline void QListWidgetItem::setFont(const QFont &amp;afont)</a>
<a name="198"><span class="lineNum">     198 </span>            : { setData(Qt::FontRole, afont); }</a>
<a name="199"><span class="lineNum">     199 </span>            : </a>
<a name="200"><span class="lineNum">     200 </span>            : #ifndef QT_NO_DATASTREAM</a>
<a name="201"><span class="lineNum">     201 </span>            : Q_WIDGETS_EXPORT QDataStream &amp;operator&lt;&lt;(QDataStream &amp;out, const QListWidgetItem &amp;item);</a>
<a name="202"><span class="lineNum">     202 </span>            : Q_WIDGETS_EXPORT QDataStream &amp;operator&gt;&gt;(QDataStream &amp;in, QListWidgetItem &amp;item);</a>
<a name="203"><span class="lineNum">     203 </span>            : #endif</a>
<a name="204"><span class="lineNum">     204 </span>            : </a>
<a name="205"><span class="lineNum">     205 </span>            : class QListWidgetPrivate;</a>
<a name="206"><span class="lineNum">     206 </span>            : </a>
<a name="207"><span class="lineNum">     207 </span>            : class Q_WIDGETS_EXPORT QListWidget : public QListView</a>
<a name="208"><span class="lineNum">     208 </span>            : {</a>
<a name="209"><span class="lineNum">     209 </span>            :     Q_OBJECT</a>
<a name="210"><span class="lineNum">     210 </span>            :     Q_PROPERTY(int count READ count)</a>
<a name="211"><span class="lineNum">     211 </span>            :     Q_PROPERTY(int currentRow READ currentRow WRITE setCurrentRow NOTIFY currentRowChanged USER true)</a>
<a name="212"><span class="lineNum">     212 </span>            :     Q_PROPERTY(bool sortingEnabled READ isSortingEnabled WRITE setSortingEnabled)</a>
<a name="213"><span class="lineNum">     213 </span>            : </a>
<a name="214"><span class="lineNum">     214 </span>            :     friend class QListWidgetItem;</a>
<a name="215"><span class="lineNum">     215 </span>            :     friend class QListModel;</a>
<a name="216"><span class="lineNum">     216 </span>            : public:</a>
<a name="217"><span class="lineNum">     217 </span>            :     explicit QListWidget(QWidget *parent = nullptr);</a>
<a name="218"><span class="lineNum">     218 </span>            :     ~QListWidget();</a>
<a name="219"><span class="lineNum">     219 </span>            : </a>
<a name="220"><span class="lineNum">     220 </span>            :     void setSelectionModel(QItemSelectionModel *selectionModel) override;</a>
<a name="221"><span class="lineNum">     221 </span>            : </a>
<a name="222"><span class="lineNum">     222 </span>            :     QListWidgetItem *item(int row) const;</a>
<a name="223"><span class="lineNum">     223 </span>            :     int row(const QListWidgetItem *item) const;</a>
<a name="224"><span class="lineNum">     224 </span>            :     void insertItem(int row, QListWidgetItem *item);</a>
<a name="225"><span class="lineNum">     225 </span>            :     void insertItem(int row, const QString &amp;label);</a>
<a name="226"><span class="lineNum">     226 </span>            :     void insertItems(int row, const QStringList &amp;labels);</a>
<a name="227"><span class="lineNum">     227 </span><span class="lineCov">         47 :     inline void addItem(const QString &amp;label) { insertItem(count(), label); }</span></a>
<a name="228"><span class="lineNum">     228 </span>            :     inline void addItem(QListWidgetItem *item);</a>
<a name="229"><span class="lineNum">     229 </span>            :     inline void addItems(const QStringList &amp;labels) { insertItems(count(), labels); }</a>
<a name="230"><span class="lineNum">     230 </span>            :     QListWidgetItem *takeItem(int row);</a>
<a name="231"><span class="lineNum">     231 </span>            :     int count() const;</a>
<a name="232"><span class="lineNum">     232 </span>            : </a>
<a name="233"><span class="lineNum">     233 </span>            :     QListWidgetItem *currentItem() const;</a>
<a name="234"><span class="lineNum">     234 </span>            :     void setCurrentItem(QListWidgetItem *item);</a>
<a name="235"><span class="lineNum">     235 </span>            :     void setCurrentItem(QListWidgetItem *item, QItemSelectionModel::SelectionFlags command);</a>
<a name="236"><span class="lineNum">     236 </span>            : </a>
<a name="237"><span class="lineNum">     237 </span>            :     int currentRow() const;</a>
<a name="238"><span class="lineNum">     238 </span>            :     void setCurrentRow(int row);</a>
<a name="239"><span class="lineNum">     239 </span>            :     void setCurrentRow(int row, QItemSelectionModel::SelectionFlags command);</a>
<a name="240"><span class="lineNum">     240 </span>            : </a>
<a name="241"><span class="lineNum">     241 </span>            :     QListWidgetItem *itemAt(const QPoint &amp;p) const;</a>
<a name="242"><span class="lineNum">     242 </span>            :     inline QListWidgetItem *itemAt(int x, int y) const;</a>
<a name="243"><span class="lineNum">     243 </span>            :     QRect visualItemRect(const QListWidgetItem *item) const;</a>
<a name="244"><span class="lineNum">     244 </span>            : </a>
<a name="245"><span class="lineNum">     245 </span>            :     void sortItems(Qt::SortOrder order = Qt::AscendingOrder);</a>
<a name="246"><span class="lineNum">     246 </span>            :     void setSortingEnabled(bool enable);</a>
<a name="247"><span class="lineNum">     247 </span>            :     bool isSortingEnabled() const;</a>
<a name="248"><span class="lineNum">     248 </span>            : </a>
<a name="249"><span class="lineNum">     249 </span>            :     void editItem(QListWidgetItem *item);</a>
<a name="250"><span class="lineNum">     250 </span>            :     void openPersistentEditor(QListWidgetItem *item);</a>
<a name="251"><span class="lineNum">     251 </span>            :     void closePersistentEditor(QListWidgetItem *item);</a>
<a name="252"><span class="lineNum">     252 </span>            :     using QAbstractItemView::isPersistentEditorOpen;</a>
<a name="253"><span class="lineNum">     253 </span>            :     bool isPersistentEditorOpen(QListWidgetItem *item) const;</a>
<a name="254"><span class="lineNum">     254 </span>            : </a>
<a name="255"><span class="lineNum">     255 </span>            :     QWidget *itemWidget(QListWidgetItem *item) const;</a>
<a name="256"><span class="lineNum">     256 </span>            :     void setItemWidget(QListWidgetItem *item, QWidget *widget);</a>
<a name="257"><span class="lineNum">     257 </span>            :     inline void removeItemWidget(QListWidgetItem *item);</a>
<a name="258"><span class="lineNum">     258 </span>            : </a>
<a name="259"><span class="lineNum">     259 </span>            : #if QT_DEPRECATED_SINCE(5, 13)</a>
<a name="260"><span class="lineNum">     260 </span>            :     QT_DEPRECATED_X (&quot;Use QListWidgetItem::isSelected() instead&quot;)</a>
<a name="261"><span class="lineNum">     261 </span>            :     bool isItemSelected(const QListWidgetItem *item) const;</a>
<a name="262"><span class="lineNum">     262 </span>            :     QT_DEPRECATED_X (&quot;Use QListWidgetItem::setSelected() instead&quot;)</a>
<a name="263"><span class="lineNum">     263 </span>            :     void setItemSelected(const QListWidgetItem *item, bool select);</a>
<a name="264"><span class="lineNum">     264 </span>            : #endif</a>
<a name="265"><span class="lineNum">     265 </span>            :     QList&lt;QListWidgetItem*&gt; selectedItems() const;</a>
<a name="266"><span class="lineNum">     266 </span>            :     QList&lt;QListWidgetItem*&gt; findItems(const QString &amp;text, Qt::MatchFlags flags) const;</a>
<a name="267"><span class="lineNum">     267 </span>            : </a>
<a name="268"><span class="lineNum">     268 </span>            : #if QT_DEPRECATED_SINCE(5, 13)</a>
<a name="269"><span class="lineNum">     269 </span>            :     QT_DEPRECATED_X (&quot;Use QListWidgetItem::isHidden() instead&quot;)</a>
<a name="270"><span class="lineNum">     270 </span>            :     bool isItemHidden(const QListWidgetItem *item) const;</a>
<a name="271"><span class="lineNum">     271 </span>            :     QT_DEPRECATED_X (&quot;Use QListWidgetItem::setHidden() instead&quot;)</a>
<a name="272"><span class="lineNum">     272 </span>            :     void setItemHidden(const QListWidgetItem *item, bool hide);</a>
<a name="273"><span class="lineNum">     273 </span>            : #endif</a>
<a name="274"><span class="lineNum">     274 </span>            : #if QT_VERSION &gt;= QT_VERSION_CHECK(6, 0, 0)</a>
<a name="275"><span class="lineNum">     275 </span>            : protected:</a>
<a name="276"><span class="lineNum">     276 </span>            : #endif</a>
<a name="277"><span class="lineNum">     277 </span>            : #if QT_CONFIG(draganddrop)</a>
<a name="278"><span class="lineNum">     278 </span>            :     void dropEvent(QDropEvent *event) override;</a>
<a name="279"><span class="lineNum">     279 </span>            : #endif</a>
<a name="280"><span class="lineNum">     280 </span>            : public Q_SLOTS:</a>
<a name="281"><span class="lineNum">     281 </span>            :     void scrollToItem(const QListWidgetItem *item, QAbstractItemView::ScrollHint hint = EnsureVisible);</a>
<a name="282"><span class="lineNum">     282 </span>            :     void clear();</a>
<a name="283"><span class="lineNum">     283 </span>            : </a>
<a name="284"><span class="lineNum">     284 </span>            : Q_SIGNALS:</a>
<a name="285"><span class="lineNum">     285 </span>            :     void itemPressed(QListWidgetItem *item);</a>
<a name="286"><span class="lineNum">     286 </span>            :     void itemClicked(QListWidgetItem *item);</a>
<a name="287"><span class="lineNum">     287 </span>            :     void itemDoubleClicked(QListWidgetItem *item);</a>
<a name="288"><span class="lineNum">     288 </span>            :     void itemActivated(QListWidgetItem *item);</a>
<a name="289"><span class="lineNum">     289 </span>            :     void itemEntered(QListWidgetItem *item);</a>
<a name="290"><span class="lineNum">     290 </span>            :     // ### Qt 6: add changed roles</a>
<a name="291"><span class="lineNum">     291 </span>            :     void itemChanged(QListWidgetItem *item);</a>
<a name="292"><span class="lineNum">     292 </span>            : </a>
<a name="293"><span class="lineNum">     293 </span>            :     void currentItemChanged(QListWidgetItem *current, QListWidgetItem *previous);</a>
<a name="294"><span class="lineNum">     294 </span>            :     void currentTextChanged(const QString &amp;currentText);</a>
<a name="295"><span class="lineNum">     295 </span>            :     void currentRowChanged(int currentRow);</a>
<a name="296"><span class="lineNum">     296 </span>            : </a>
<a name="297"><span class="lineNum">     297 </span>            :     void itemSelectionChanged();</a>
<a name="298"><span class="lineNum">     298 </span>            : </a>
<a name="299"><span class="lineNum">     299 </span>            : protected:</a>
<a name="300"><span class="lineNum">     300 </span>            :     bool event(QEvent *e) override;</a>
<a name="301"><span class="lineNum">     301 </span>            :     virtual QStringList mimeTypes() const;</a>
<a name="302"><span class="lineNum">     302 </span>            : #if QT_VERSION &gt;= QT_VERSION_CHECK(6,0,0)</a>
<a name="303"><span class="lineNum">     303 </span>            :     virtual QMimeData *mimeData(const QList&lt;QListWidgetItem *&gt; &amp;items) const;</a>
<a name="304"><span class="lineNum">     304 </span>            : #else</a>
<a name="305"><span class="lineNum">     305 </span>            :     virtual QMimeData *mimeData(const QList&lt;QListWidgetItem*&gt; items) const;</a>
<a name="306"><span class="lineNum">     306 </span>            : #endif</a>
<a name="307"><span class="lineNum">     307 </span>            : #if QT_CONFIG(draganddrop)</a>
<a name="308"><span class="lineNum">     308 </span>            :     virtual bool dropMimeData(int index, const QMimeData *data, Qt::DropAction action);</a>
<a name="309"><span class="lineNum">     309 </span>            :     virtual Qt::DropActions supportedDropActions() const;</a>
<a name="310"><span class="lineNum">     310 </span>            : #endif</a>
<a name="311"><span class="lineNum">     311 </span>            : </a>
<a name="312"><span class="lineNum">     312 </span>            : #if QT_VERSION &gt;= QT_VERSION_CHECK(6, 0, 0)</a>
<a name="313"><span class="lineNum">     313 </span>            : public:</a>
<a name="314"><span class="lineNum">     314 </span>            : #else</a>
<a name="315"><span class="lineNum">     315 </span>            : protected:</a>
<a name="316"><span class="lineNum">     316 </span>            : #endif</a>
<a name="317"><span class="lineNum">     317 </span>            :     QList&lt;QListWidgetItem*&gt; items(const QMimeData *data) const;</a>
<a name="318"><span class="lineNum">     318 </span>            : </a>
<a name="319"><span class="lineNum">     319 </span>            :     QModelIndex indexFromItem(const QListWidgetItem *item) const;</a>
<a name="320"><span class="lineNum">     320 </span>            : #if QT_VERSION &lt; QT_VERSION_CHECK(6, 0, 0)</a>
<a name="321"><span class="lineNum">     321 </span>            :     QModelIndex indexFromItem(QListWidgetItem *item) const; // ### Qt 6: remove</a>
<a name="322"><span class="lineNum">     322 </span>            : #endif</a>
<a name="323"><span class="lineNum">     323 </span>            :     QListWidgetItem *itemFromIndex(const QModelIndex &amp;index) const;</a>
<a name="324"><span class="lineNum">     324 </span>            : </a>
<a name="325"><span class="lineNum">     325 </span>            : private:</a>
<a name="326"><span class="lineNum">     326 </span>            :     void setModel(QAbstractItemModel *model) override;</a>
<a name="327"><span class="lineNum">     327 </span>            :     Qt::SortOrder sortOrder() const;</a>
<a name="328"><span class="lineNum">     328 </span>            : </a>
<a name="329"><span class="lineNum">     329 </span>            :     Q_DECLARE_PRIVATE(QListWidget)</a>
<a name="330"><span class="lineNum">     330 </span>            :     Q_DISABLE_COPY(QListWidget)</a>
<a name="331"><span class="lineNum">     331 </span>            : </a>
<a name="332"><span class="lineNum">     332 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_emitItemPressed(const QModelIndex &amp;index))</a>
<a name="333"><span class="lineNum">     333 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_emitItemClicked(const QModelIndex &amp;index))</a>
<a name="334"><span class="lineNum">     334 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_emitItemDoubleClicked(const QModelIndex &amp;index))</a>
<a name="335"><span class="lineNum">     335 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_emitItemActivated(const QModelIndex &amp;index))</a>
<a name="336"><span class="lineNum">     336 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_emitItemEntered(const QModelIndex &amp;index))</a>
<a name="337"><span class="lineNum">     337 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_emitItemChanged(const QModelIndex &amp;index))</a>
<a name="338"><span class="lineNum">     338 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_emitCurrentItemChanged(const QModelIndex &amp;previous, const QModelIndex &amp;current))</a>
<a name="339"><span class="lineNum">     339 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_sort())</a>
<a name="340"><span class="lineNum">     340 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_dataChanged(const QModelIndex &amp;topLeft, const QModelIndex &amp;bottomRight))</a>
<a name="341"><span class="lineNum">     341 </span>            : };</a>
<a name="342"><span class="lineNum">     342 </span>            : </a>
<a name="343"><span class="lineNum">     343 </span>            : inline void QListWidget::removeItemWidget(QListWidgetItem *aItem)</a>
<a name="344"><span class="lineNum">     344 </span>            : { setItemWidget(aItem, nullptr); }</a>
<a name="345"><span class="lineNum">     345 </span>            : </a>
<a name="346"><span class="lineNum">     346 </span>            : inline void QListWidget::addItem(QListWidgetItem *aitem)</a>
<a name="347"><span class="lineNum">     347 </span>            : { insertItem(count(), aitem); }</a>
<a name="348"><span class="lineNum">     348 </span>            : </a>
<a name="349"><span class="lineNum">     349 </span>            : inline QListWidgetItem *QListWidget::itemAt(int ax, int ay) const</a>
<a name="350"><span class="lineNum">     350 </span>            : { return itemAt(QPoint(ax, ay)); }</a>
<a name="351"><span class="lineNum">     351 </span>            : </a>
<a name="352"><span class="lineNum">     352 </span>            : inline void QListWidgetItem::setHidden(bool ahide)</a>
<a name="353"><span class="lineNum">     353 </span>            : { if (view) view-&gt;setRowHidden(view-&gt;row(this), ahide); }</a>
<a name="354"><span class="lineNum">     354 </span>            : </a>
<a name="355"><span class="lineNum">     355 </span>            : inline bool QListWidgetItem::isHidden() const</a>
<a name="356"><span class="lineNum">     356 </span>            : { return (view ? view-&gt;isRowHidden(view-&gt;row(this)) : false); }</a>
<a name="357"><span class="lineNum">     357 </span>            : </a>
<a name="358"><span class="lineNum">     358 </span>            : QT_END_NAMESPACE</a>
<a name="359"><span class="lineNum">     359 </span>            : </a>
<a name="360"><span class="lineNum">     360 </span>            : #endif // QLISTWIDGET_H</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
